#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>

void increment(int *counts)
{
    counts[0]++;
    counts[1]++;
    counts[1]++;
    counts[8] = 8;
}

void print_counts(int *counts)
{
    for (int i = 0; i < 10; i++) {
        printf("%d: %d\n", i, counts[i]);
    }
    printf("====\n");
}

void update_counts(int *counts)
{
    counts[4]++;
    counts[5]++;
}

int main()
{
    int counts[10] = {0};

    pid_t child_pid = fork();
    if (child_pid == 0) {
        update_counts(counts);
        print_counts(counts);
        return 0;
    }
    increment(counts);
    sleep(1);
    print_counts(counts);
    waitpid(child_pid, NULL, WEXITED);

    return 0;
}
