// example of setting up pipeline and run two commands.
// like: yes | head
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>

int main()
{
        int pipe1[2];
	int r;

        pipe2(pipe1, O_CLOEXEC);

	pid_t child1 = fork();
	if (child1 == 0) {
                dup2(pipe1[1], STDOUT_FILENO);
		//r = execlp("echo", "echo", "abc\ndef\n", (char *)0);
		r = execlp("yes", "yes", (char *)0);
                if (r == -1) return -1;
	}
	pid_t child2 = fork();
	if (child2 == 0) {
                dup2(pipe1[0], STDIN_FILENO);
		r = execlp("head", "head", (char *)0);
                if (r == -1) return -1;
	}
	close(pipe1[0]);
	close(pipe1[1]);
	int status;
	waitpid(child1, &status, WEXITED | WUNTRACED);
	printf("child1 exit\n");
	waitpid(child2, &status, WEXITED | WUNTRACED);
	printf("child2 exit\n");
	printf("parent exit\n");
}
