// example of setting up pipeline and run three commands.
// like: yes | head | wc -l
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>

int main()
{
        int pipefd1[2];
        int pipefd2[2];
	int r;

        pipe2(pipefd1, O_CLOEXEC);
	pid_t child1 = fork();
	if (child1 == 0) {
                dup2(pipefd1[1], STDOUT_FILENO);
		//r = execlp("echo", "echo", "abc\ndef\n", (char *)0);
		r = execlp("yes", "yes", (char *)0);
                if (r == -1) return -1;
	}

        pipe2(pipefd2, O_CLOEXEC);
	pid_t child2 = fork();
	if (child2 == 0) {
                dup2(pipefd1[0], STDIN_FILENO);
                dup2(pipefd2[1], STDOUT_FILENO);
		r = execlp("head", "head", (char *)0);
                if (r == -1) return -1;
	}
	pid_t child3 = fork();
	if (child3 == 0) {
                dup2(pipefd2[0], STDIN_FILENO);
		r = execlp("wc", "wc", "-l", (char *)0);
                if (r == -1) return -1;
	}
	close(pipefd1[0]);
	close(pipefd1[1]);
	close(pipefd2[0]);
	close(pipefd2[1]);
	int status;
	waitpid(child1, &status, WEXITED);
	waitpid(child2, &status, WEXITED);
	waitpid(child3, &status, WEXITED);
}
